commit c4989d3044295afe17b34199b9602a94f7750fda
Author: Julia Niermann <jniermann@techfak.uni-bielefeld.de>
Date:   Fri Jun 28 12:45:49 2019 +0200

    Try to fix unresolved p9221r driver dependencies

diff --git a/modules/LightRing_1-2/module.c b/modules/LightRing_1-2/module.c
index e7abe54..c97f0ba 100644
--- a/modules/LightRing_1-2/module.c
+++ b/modules/LightRing_1-2/module.c
@@ -436,6 +436,13 @@ INA219Driver moduleLldPowerMonitorVled = {
   /* configuration    */ NULL,
 };
 
+P9221RDriver moduleQiCharger = {
+  /* I2C Driver       */ &MODULE_HAL_I2C_EEPROM_PWRMTR_BREAKOUT,
+  /* I²C address      */ P9221R_LLD_I2C_ADDR_FIXED,
+  /* current LSB (uA) */ 0x00u,
+  /* configuration    */ NULL,
+};
+
 LEDDriver moduleLldStatusLed = {
   /* LED enable Gpio */ &moduleGpioLed,
 };
@@ -533,6 +540,34 @@ aos_unittest_t moduleUtAlldIna219 = {
 };
 
 /*
+ * P9221R (qi charger)
+ */
+static int _utShellCmdCb_AlldP9221r(BaseSequentialStream* stream, int argc, char* argv[])
+{
+  (void)argc;
+  (void)argv;
+  aosUtRun(stream, &moduleUtAlldP9221r, NULL);
+  return AOS_OK;
+}
+static ut_p9221rdata_t _utP9221rData = {
+  /* driver           */ &moduleLldPowerMonitorVled,
+  /* expected voltage */ 4.2f,
+  /* tolerance        */ 0.2f,
+  /* timeout */ MICROSECONDS_PER_SECOND,
+};
+aos_unittest_t moduleUtAlldP9221r = {
+  /* name           */ "P9221R",
+  /* info           */ "qi charger",
+  /* test function  */ utAlldP9221rFunc,
+  /* shell command  */ {
+    /* name     */ "unittest:QiCharger",
+    /* callback */ _utShellCmdCb_AlldP9221r,
+    /* next     */ NULL,
+  },
+  /* data           */ &_utP9221rData,
+};
+
+/*
  * Status LED
  */
 static int _utShellCmdCb_AlldLed(BaseSequentialStream* stream, int argc, char* argv[])
diff --git a/modules/LightRing_1-2/module.h b/modules/LightRing_1-2/module.h
index fd221db..e2a21e4 100644
--- a/modules/LightRing_1-2/module.h
+++ b/modules/LightRing_1-2/module.h
@@ -407,6 +407,11 @@ extern AT24C01BDriver moduleLldEeprom;
 extern INA219Driver moduleLldPowerMonitorVled;
 
 /**
+ * @brief   Power monitor (VLED 4.2) driver.
+ */
+extern P9221RDriver moduleQiCharger;
+
+/**
  * @brief   Status LED driver.
  */
 extern LEDDriver moduleLldStatusLed;
diff --git a/modules/PowerManagement_1-2/module.h b/modules/PowerManagement_1-2/module.h
index 468e72f..aff8906 100644
--- a/modules/PowerManagement_1-2/module.h
+++ b/modules/PowerManagement_1-2/module.h
@@ -444,6 +444,7 @@ extern ROMCONST char* moduleShellPrompt;
   aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500.shellcmd);              \
   aosShellAddCommand(&aos.shell, &moduleUtAlldBq27500Bq24103a.shellcmd);      \
   aosShellAddCommand(&aos.shell, &moduleUtAlldIna219.shellcmd);               \
+  aosShellAddCommand(&aos.shell, &moduleUtAlldP9221r.shellcmd);               \
   aosShellAddCommand(&aos.shell, &moduleUtAlldPklcs1212e4001.shellcmd);       \
   aosShellAddCommand(&aos.shell, &moduleUtAlldLed.shellcmd);                  \
   aosShellAddCommand(&aos.shell, &moduleUtAlldTps62113.shellcmd);             \
@@ -595,6 +596,7 @@ extern ROMCONST char* moduleShellPrompt;
 #include <alld_bq241xx.h>
 #include <alld_bq27500.h>
 #include <alld_INA219.h>
+#include <alld_P9221R.h>
 #include <alld_LED.h>
 #include <alld_PKxxxExxx.h>
 #include <alld_TPS6211x.h>
@@ -752,6 +754,7 @@ extern AT42QT1050Driver moduleLldTouch;
 #include <ut_alld_bq27500_v1.h>
 #include <ut_alld_bq27500_v1_bq241xx_v1.h>
 #include <ut_alld_INA219_v1.h>
+#include <ut_alld_P9221R_v1.h>
 #include <ut_alld_LED_v1.h>
 #include <ut_alld_PKxxxExxx_v1.h>
 #include <ut_alld_TPS6211x_v1.h>
@@ -788,6 +791,11 @@ extern aos_unittest_t moduleUtAlldBq27500Bq24103a;
 extern aos_unittest_t moduleUtAlldIna219;
 
 /**
+ * @brief   P9221R (qi charger) unit test object.
+ */
+extern aos_unittest_t moduleUtAlldP9221r;
+
+/**
  * @brief   Status LED unit test object.
  */
 extern aos_unittest_t moduleUtAlldLed;
diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index 1473a57..7aa812e 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit 1473a57f96b8bcbcac3400ca3458b7a08fed5881
+Subproject commit 7aa812e97bfc19fb3259858dc76fd3b21d18afb9